<template>
  <div class="admin flex">
    <div class="admin__right-side h-full relative bg-bgdtert">
      <img width="220" height="16" src="@/assets/images/admin/logotype.svg" class="absolute top-16 left-16" />
      <img width="24" height="24" src="@/assets/images/admin/ship.svg" class="absolute bottom-16 left-16" />
    </div>
    <div class="flex-1 bg-bgdprim h-full flex flex-col items-start justify-center h-full pl-32">
      <div class="admin__content">
        <div
          class="rounded-12 bg-btndsec w-max h-8 rounded-12 px-2 flex justify-center items-center text-txtdsec font-medium text-sm"
        >
          ADMIN PANEL
        </div>
        <p class="text-txtdprim mt-8 font-bold text-3xl leading-10">Connect wallet</p>
        <p class="mt-4 text-txtdsec leading-7 text-xl">
          Choose how you want to connect. There <br />are several wallet providers.
        </p>
        <div class="mt-8 flex items-center gap-4 relative">
          <div class="h-0.5 w-full absolute bottom-0 left-0 bg-brdddef rounded-100"></div>
          <div
            v-for="network in networks"
            :key="network.chainId"
            class="h-9 cursor-pointer relative hover:text-txtdprim px-1"
            :class="currentNetwork.chainId === network.chainId ? 'text-txtdprim' : 'text-txtdsec'"
            @click="chooseNetwork(network)"
          >
            <p class="text-center leading-5 font-medium">
              {{ network.title }}
            </p>
            <div
              v-show="currentNetwork.chainId === network.chainId"
              style="height: 3px; transform: translateY(0.5px)"
              class="w-full absolute bottom-0 left-0 rounded-100 bg-blue"
            ></div>
          </div>
        </div>
        <UiButton
          color-type="secondary"
          button-height="md"
          class="mt-8 rounded-24 w-full pl-4 pr-5 gap-3"
          @click="login"
        >
          <img width="32" height="32" src="@/assets/images/connect-modal/metamask.svg" />
          <p class="flex-1">MetaMask</p>
          <img v-if="!loading" width="24" height="24" src="@/assets/images/connect-modal/arrow-right.svg" />
          <LoadingSpinner v-else />
        </UiButton>
      </div>
    </div>
  </div>
</template>

<script>
import Cookies from 'js-cookie';

import UiButton from '@/components/ui/UiButton.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';

export default {
  name: 'AdminLogin',

  components: { UiButton, LoadingSpinner},

  data() {
    return {
      networks: [
        {
          title: 'Ethereum',
          key: 'ETH',
          chainId: 1,
        },
        {
          title: 'BNB Chain',
          key: 'BNB',
          chainId: 56,
        },
        {
          title: 'Polygon',
          key: 'MATIC',
          chainId: 137,
        },
      ],
    };
  },

  computed: {
    loading() {
      return this.$store.state.system.isWalletConnecting;
    },

    currentNetwork() {
      return this.$store.state.auth.currentNetwork;
    },
  },

  methods: {
    chooseNetwork(network) {
      if (this.loading) return;
      this.$store.commit('setCurrentNetwork', network);
      Cookies.set('flashNetwork', network.key);
    },

    login() {
      this.$store.dispatch('linkWallet');
    },

    checkNetwork() {
      const networkKey = Cookies.get('flashNetwork');
      if (!networkKey) return;
      const network = this.networks.find((network) => network.key === networkKey);
      this.chooseNetwork(network);
    },
  },
};
</script>
